studygovernor/views.py
# Copyright 2017 Biomedical Imaging Group Rotterdam, Departments of
# Medical Informatics and Radiology, Erasmus MC, Rotterdam, The Netherlands
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

from pathlib import Path

from flask import abort, render_template, Blueprint, request, current_app
from flask_security import current_user
from flask_security import login_required
from flask_security import permissions_accepted
from flask_wtf import FlaskForm
from flask_wtf.file import FileField, FileRequired
from werkzeug.utils import secure_filename
from wtforms import TextField, TextAreaField, SubmitField, SelectMultipleField
from wtforms.validators import DataRequired

from collections import defaultdict

from . import control, models
from .util.mail import send_bulk_mail
from .util.helpers import get_object_from_arg

ITEMS_PER_PAGE = 15

# Get app and db
bp = Blueprint('web', __name__)


# Web resources
@bp.app_errorhandler(404)
def page_not_found_error(error):
    title = f'Taskmanager: 404 Not Found'
    return render_template('error/notfound.html', title=title), 404


@bp.errorhandler(403)
def forbidden_error(error):
    title = f'Taskmanager: 403 Forbidden'
    return render_template('error/forbidden.html', title=title), 404


@bp.route('/')
@bp.route('/index')
def index():
    return render_template('index.html')


@bp.route('/states/workflow/<int:id>')
@login_required
def web_state_workflow(id):
    page = request.args.get('page', 1, type=int)
    workflows = models.Workflow.query.order_by(models.Workflow.id.asc()).all()
    states = models.State.query.filter(models.State.workflow_id == id).paginate(page=page, per_page=ITEMS_PER_PAGE)
    current_workflow = models.Workflow.query.get(id)
    return render_template('state_workflow.html', current_workflow=current_workflow, states=states, workflows=workflows)


@bp.route('/states')
@login_required
def web_states():
    workflows = models.Workflow.query.order_by(models.Workflow.id.asc()).all()
    all_states = models.State.query.join(models.Workflow).order_by(models.State.id).add_column(models.Workflow.label).all()
    states_grouped_by_label = defaultdict(list)
    for state, workflow_label in all_states:
        states_grouped_by_label[state.label].append((state, workflow_label))
    return render_template('states.html', states_grouped_by_label=states_grouped_by_label, workflows=workflows)

@bp.route('/states/<int:id>')
@login_required
def web_state(id):
    state = models.State.query.filter(models.State.id == id).one_or_none()
    return render_template('state.html', state=state)


@bp.route('/workflows')
@login_required
def web_workflows():
    page = request.args.get('page', 1, type=int)
    workflows = models.Workflow.query.order_by(models.Workflow.id.asc()).paginate(page=page, per_page=ITEMS_PER_PAGE)
    return render_template('workflows.html', workflows=workflows)


@bp.route('/workflows/<int:id>')
@login_required
def web_workflow(id):
    workflow = models.Workflow.query.filter(models.Workflow.id == id).one_or_none()
    return render_template('workflows.html', workflow=workflow)


@bp.route('/transitions/workflow/<int:id>')
@login_required
def web_transition_workflow(id):
    page = request.args.get('page', 1, type=int)
    workflows = models.Workflow.query.order_by(models.Workflow.id.asc()).all()
    transitions = models.Transition.query.join(models.State, models.Transition.source_state_id == models.State.id)\
        .filter(models.State.workflow_id == id).paginate(page=page, per_page=ITEMS_PER_PAGE)
    return render_template('transition_workflow.html', workflow_id=id, transitions=transitions, workflows=workflows)


@bp.route('/transitions')
@login_required
def web_transitions():
    page = request.args.get('page', 1, type=int)
    workflows = models.Workflow.query.order_by(models.Workflow.id.asc()).all()
    transitions = models.Transition.query.paginate(page=page, per_page=ITEMS_PER_PAGE)
    return render_template('transitions.html', transitions=transitions, workflows=workflows)


@bp.route('/transitions/<int:id>')
@login_required
def web_transition(id):
    transition = models.Transition.query.filter(models.Transition.id == id).one_or_none()
    if transition is None:
        abort(404)
    return render_template('transition.html', transition=transition)


@bp.route('/subjects')
@login_required
def web_subjects():
    page = request.args.get('page', 1, type=int)
    subjects = models.Subject.query.paginate(page=page, per_page=ITEMS_PER_PAGE)
    return render_template('subjects.html', subjects=subjects)


@bp.route('/subjects/<int:id>')
@login_required
def web_subject(id):
    subject = models.Subject.query.filter(models.Subject.id == id).one_or_none()
    if subject is None:
        abort(404)
    return render_template('subject.html', subject=subject)


@bp.route('/cohorts')
@login_required
def web_cohorts():
    page = request.args.get('page', 1, type=int)
    cohorts = models.Cohort.query.paginate(page=page, per_page=ITEMS_PER_PAGE)
    return render_template('cohorts.html', cohorts=cohorts)


@bp.route('/cohorts/<int:id>')
@login_required
def web_cohort(id):
    cohort = models.Cohort.query.filter(models.Cohort.id == id).one_or_none()
    if cohort is None:
        abort(404)
    return render_template('cohort.html', cohort=cohort)


@bp.route('/experiments')
@login_required
def web_experiments():
    page = request.args.get('page', 1, type=int)
    experiments = models.Experiment.query.paginate(page=page, per_page=ITEMS_PER_PAGE)
    return render_template('experiments.html', experiments=experiments)


@bp.route('/experiments/<int:id>')
@login_required
def web_experiment(id):
    experiment = models.Experiment.query.filter(models.Experiment.id == id).one_or_none()
    if experiment is None:
        abort(404)
    return render_template('experiment.html', experiment=experiment)


@bp.route('/callback/<int:id>')
@login_required
def web_callback(id):
    callback = models.Callback.query.filter(models.Callback.id == id).one_or_none()
    if callback is None:
        abort(404)
    return render_template('callback.html', callback=callback)


@bp.route('/callback_execution/<int:id>')
@login_required
def web_callback_execution(id):
    callback_execution = models.CallbackExecution.query.filter(models.CallbackExecution.id == id).one_or_none()
    if callback_execution is None:
        abort(404)
    return render_template('callback_execution.html', callback_execution=callback_execution)


@bp.route('/actions/<int:id>')
@login_required
def web_action(id):
    action = models.Action.query.filter(models.Action.id == id).one_or_none()
    if action is None:
        abort(404)
    return render_template('action.html', action=action)


@bp.route('/users')
@login_required
@permissions_accepted('roles_manage')
def users():
    page = request.args.get('page', 1, type=int)
    data = models.User.query.paginate(page=page, per_page=ITEMS_PER_PAGE)
    roles = models.Role.query.order_by(models.Role.id).all()
    return render_template('userroles.html', data=data, roles=roles)


@bp.route('/users/<int:id>')
@login_required
def user(id):
    data = models.User.query.filter(models.User.id == id).one_or_none()
    if data is None:
        abort(404)

    if not current_user.has_permission('user_read_all'):
        # This is a normal user, so may only see own user information.
        if current_user != data:
            abort(403)

    return render_template('user.html', data=data)


class MailForm(FlaskForm):
    recipients = SelectMultipleField('Recipients')
    subject = TextField('Subject', validators=[DataRequired()])
    body = TextAreaField('Message', validators=[DataRequired()])
    submit = SubmitField('Send')


@bp.route("/mail", methods=['GET', 'POST'])
@login_required
@permissions_accepted('user_read_all')
def mail():
    form = MailForm(request.form)

    form.recipients.choices = ((u.username, f'{u.name} <{u.email}>') for u in models.User.query.all())

    if form.validate_on_submit():
        recipients = form.recipients.data
        subject = form.subject.data
        body = form.body.data

        if recipients:
            recipients = [get_object_from_arg(x, models.User, models.User.username, skip_id=True) for x in recipients]
        else:
            recipients = models.User.query.all()

        send_bulk_mail(
            recipients=recipients,
            subject=subject,
            body=body,
        )
        return render_template('mail_sent.html',
                               recipients=recipients,
                               subject=subject,
                               body=body)

    return render_template('mail.html', mail_form=form)


class ImportDataForm(FlaskForm):
    file_field = FileField("File to upload", validators=[
        FileRequired(),
    ])
    submit = SubmitField('Send')


@bp.route('/upload_data', methods=['GET', 'POST'])
@login_required
@permissions_accepted('upload_data')
def upload_data():
    form = ImportDataForm()

    success = False
    message = False

    if form.validate_on_submit():
        print('Form submitted, checking data...')
        filename = form.file_field.data.filename
        print(f'Original filename: {filename}')
        filename = secure_filename(filename=filename)

        try:
            data_directory = Path(current_app.config['STUDYGOV_DATA_DIR'])
            target_path = data_directory / filename
            form.file_field.data.save(target_path)

studygovernor/templates/cohort.html
{% extends "base.html" %}
{% from "_macros.html" import collapse_card_start, collapse_card_end %}
{% block content %}


<h1>Cohort {{ cohort.label }} </h1>

{{ collapse_card_start("Cohort Information", show=True)}}
    <dl class="dl-horizontal">
      <dt>id</dt>
      <dd>{{ cohort.id }}</dd>

      <dt>label</dt>
      <dd>{{ cohort.label }}</dd>

      <dt>description</dt>
      <dd>{{ cohort.description }}</dd>

      {% if cohort.external_urls %}
      <dt>external urls</dt>
      <dd><p>
        {% for external_system, external_url in cohort.external_urls.items() %}
        <span class="badge badge-success">{{ external_system }}: {{ external_url }}</span>
        {% endfor %}
      </p></dd>
      {% endif %}
    </dl>
{{ collapse_card_end("Cohort Information")}}

{% if cohort.subjects %}
{{ collapse_card_start("Subjects", show=True) }}
      <table class="table table-striped">
        <thead>
        <tr>
          <th>id</th>
          <th>label</th>
          <th>scan date</th>
        </tr>
        </thead>
        <tbody>
        {% for subject in cohort.subjects[:25] %}
        <tr>
          <td>
            <a href="{{ url_for('web.web_subject', id=subject.id) }}">
              {{subject.id}}
            </a>
          </td>
          <td>
            <a href="{{ url_for('web.web_subject', id=subject.id) }}">
              {{subject.label}}
            </a>
          </td>
          <td>{{subject.scandate}}</td>
        </tr>
        {% endfor %}
        </tbody>
      </table>
      {% if cohort.subjects | length > 25 %}
        <p>First 25 subjects of {{ cohort.subjects | length }} displayed. All subjects from this cohort are available <a href="{{ url_for('web.web_subjects') }}">here</a></p>
      {% endif %}
{{ collapse_card_end("Subjects") }}
{% endif %}

{% endblock %}

studygovernor/templates/experiment.html
{% extends "base.html" %}
{% from "_macros.html" import collapse_card_start, collapse_card_end %}
{% block content %}


<h1>Experiment {{ experiment.label}} </h1>

    {{ collapse_card_start("Info") }}
      <dl class="row">
        <dt class="col-sm-3">id</dt>
        <dd class="col-sm-9">{{ experiment.id }}</dd>

        <dt class="col-sm-3">label</dt>
        <dd class="col-sm-9">{{ experiment.label }}</dd>

        <dt class="col-sm-3">subject</dt>
        <dd class="col-sm-9">
          <a href="{{url_for('web.web_subject', id=experiment.subject.id) }}">
            [{{ experiment.subject.id }}] {{ experiment.subject.label }}
          </a>
        </dd>

        {% if experiment.external_experiment_links %}
        <dt class="col-sm-3">external ids</dt>
        <dd class="col-sm-9"><p>
          {% for external_exp in experiment.external_experiment_links %}
          <span class="badge badge-primary">{{ external_exp.external_system.system_name }}: {{ external_exp.external_id }}</span>
          {% endfor %}
        </p></dd>
        {% endif %}

        <dt class="col-sm-3">scan date</dt>
        <dd class="col-sm-9">{{ experiment.scandate }}</dd>

        <dt class="col-sm-3">state</dt>
        <dd class="col-sm-9">
          <a href="{{url_for('web.web_state', id=experiment.state.id) }}">
            [{{ experiment.state.id }}] {{ experiment.state.label }}
          </a>
        </dd>

      </dl>
    {{ collapse_card_end("Info") }}


{{ collapse_card_start("Variables", data_count=experiment.variable_map|length) }}
<table class="table table-striped">
  <thead>
  <tr>
    <th>variable name</th>
    <th>value</th>
  </tr>
  </thead>
  <tbody>
  {% for name, value in experiment.variable_map.items() | sort(attribute='id')  %}
  <tr>
    <td>{{name}}</td>
    <td>{{value | yaml_dump }}</td>
  </tr>
  {% endfor %}
  </tbody>
</table>
{{ collapse_card_end("Variables") }}


{{ collapse_card_start("Actions", data_count=experiment.actions|length) }}
  <table class="table table-striped">
    <thead>
    <tr>
      <th>id</th>
      <th>time</th>
      <th>start state</th>
      <th>end state</th>
      <th>action finished</th>
      <th>description</th>
    </tr>
    </thead>
    <tbody>
    {% for action in experiment.actions | sort(attribute='id')  %}
    <tr>
      <td>
        <a href="{{url_for('web.web_action', id=action.id) }}">
          {{action.id}}
        </a>
      </td>
      <td>{{action.start_time}}</td>
      <td>
        <a href="{{url_for('web.web_state', id=action.transition.source_state.id) }}">
          [{{action.transition.source_state.id}}] {{action.transition.source_state.label}}
        </a>
      </td>
      <td>
        <a href="{{url_for('web.web_state', id=action.transition.destination_state.id) }}">
          [{{action.transition.destination_state.id}}] {{action.transition.destination_state.label}}
        </a>
      </td>
      <td>{{action.end_time}}</td>
      <td>{{action.freetext}}</td>
    </tr>
    {% endfor %}
    </tbody>
  </table>
{{ collapse_card_end("Actions") }}

{% endblock %}

studygovernor/templates/experiments.html
{% extends "base.html" %}
{% from "_macros.html" import collapse_card_start, collapse_card_end, paginate %}

{% block content %}


<h1>Experiments Overview</h1>
  {{ collapse_card_start("Experiments", show=True, data_count=experiments.total) }}
    <table class="table table-striped">
      <thead>
      <tr>
        <th>id</th>
        <th>label</th>
        <th>scan date</th>
        <th>state</th>
        <th>workflow</th>
        <th>subject</th>
      </tr>
      </thead>
      <tbody>
      {% for experiment in experiments.items %}
      <tr>
        <td>
          <a href="{{ url_for('web.web_experiment', id=experiment.id) }}">
            {{experiment.id}}
          </a>
        </td>
        <td>
          <a href="{{ url_for('web.web_experiment', id=experiment.id) }}">
            {{experiment.label}}
          </a>
        </td>
        <td>{{experiment.scandate}}</td>
        <td>
          <a href="{{ url_for('web.web_state', id=experiment.state.id) }}">
            [{{ experiment.state.id }}] {{experiment.state.label }}
          </a>
        </td>
        <td>
            <a href="{{ url_for('web.web_state', id=experiment.state.id) }}">
              [{{ experiment.state.workflow_id }}] {{experiment.state.workflow_label }}
            </a>
          </td>
        <td>
          <a href="{{ url_for('web.web_subject', id=experiment.subject.id) }}">
            [{{experiment.subject.id}}] {{experiment.subject.label}}
          </a>
        </td>
      </tr>
      {% endfor %}
      </tbody>
    </table>
    
    {{ paginate(experiments, 'web.web_experiments') }}

  {{ collapse_card_end("Experiments") }}

{% endblock %}

studygovernor/templates/state.html
{% extends "base.html" %}
{% from "_macros.html" import collapse_card_start, collapse_card_end %}
{% block content %}


<h1>State {{ state.label}} </h1>

{{ collapse_card_start("Info", show=True) }}
      <dl class="row">
        <dt class="col-sm-3">id</dt>
        <dd class="col-sm-9">{{ state.id }}</dd>

        <dt class="col-sm-3">label</dt>
        <dd class="col-sm-9">{{ state.label }}</dd>

        <dt class="col-sm-3">workflow</dt>
        <dd class="col-sm-9">
          <a href="{{ url_for('web.web_state_workflow', id=state.workflow.id) }}">
            <span class="badge badge-primary">{{ state.workflow.label }}</span>
          </a>
        </dd>

        <dt class="col-sm-3">lifespan</dt>
        <dd class="col-sm-9">{{ state.lifespan }}</dd>

        <dt class="col-sm-3">description</dt>
        <dd class="col-sm-9">{{ state.freetext }}</dd>
      </dl>
{{ collapse_card_end("Info") }}

{% if state.transition_destinations %}
    {{ collapse_card_start("Incoming Transitions", show=True) }}
      <table class="table table-striped">
        <thead>
        <tr>
          <th>id</th>
          <th>source</th>
          <th>destination</th>
          <th>conditions</th>
        </tr>
        </thead>
        <tbody>
        {% for transition in state.transition_destinations | sort(attribute='id') %}
        <tr>
          <td>
              <a href="{{url_for('web.web_transition', id=transition.id) }}">
                  {{transition.id}}
              </a>
          </td>
          <td>
              <a href="{{url_for('web.web_state', id=transition.source_state_id) }}">
                  [{{transition.source_state_id}}] {{transition.source_state.label}}
              </a>
          </td>
          <td>
              <a href="{{url_for('web.web_state', id=transition.destination_state_id) }}">
                 [{{transition.destination_state_id}}] {{transition.destination_state.label}}
              </a>
          </td>
          <td>
            <code>
                {{ transition.condition }}
            </code>
          </td>
        </tr>
        {% endfor %}
        </tbody>
      </table>
    {{ collapse_card_end("Incoming Transitions") }}
{% endif %}

{% if state.transition_sources %}
    {{ collapse_card_start("Outgoing Transitions", show=True) }}
      <table class="table table-striped">
        <thead>
        <tr>
          <th>id</th>
          <th>source</th>
          <th>destination</th>
          <th>conditions</th>
        </tr>
        </thead>
        <tbody>
        {% for transition in state.transition_sources | sort(attribute='id') %}
        <tr>
          <td>
              <a href="{{url_for('web.web_transition', id=transition.id) }}">
                  {{transition.id}}
              </a>
          </td>
          <td>
              <a href="{{url_for('web.web_state', id=transition.source_state_id) }}">
                  [{{transition.source_state_id}}] {{transition.source_state.label}}
              </a>
          </td>
          <td>
              <a href="{{url_for('web.web_state', id=transition.destination_state_id) }}">
                 [{{transition.destination_state_id}}] {{transition.destination_state.label}}
              </a>
          </td>
          <td>
              <code>
                  {{ transition.condition }}
              </code>
          </td>
        </tr>
        {% endfor %}
        </tbody>
      </table>
    {{ collapse_card_end("Incoming Transitions") }}
{% endif %}

{% if state.experiments %}
    {{ collapse_card_start("Experiments", show=True, data_count=state.experiments|length) }}
      <table class="table table-striped">
        <thead>
        <tr>
          <th>id</th>
          <th>label</th>
          <th>scan date</th>
          <th>subject</th>
        </tr>
        </thead>
        <tbody>
        {% for experiment in state.experiments | sort(attribute='id') %}
        <tr>
          <td>
            <a href="{{ url_for('web.web_experiment', id=experiment.id) }}">
              {{experiment.id}}
            </a>
          </td>
          <td>
            <a href="{{ url_for('web.web_experiment', id=experiment.id) }}">
              {{experiment.label}}
            </a>
          </td>
          <td>{{experiment.scandate}}</td>
          <td>
            <a href="{{ url_for('web.web_subject', id=experiment.subject.id) }}">
              [{{experiment.subject.id}}] {{experiment.subject.label}}
            </a>
          </td>
        </tr>
        {% endfor %}
        </tbody>
      </table>
    {{ collapse_card_end("Experiments") }}
{% endif %}

{{ collapse_card_start("Callbacks", data_count=state.callbacks|length) }}
<table class="table table-striped">
    <thead>
    <tr>
        <th>label</th>
        <th>function</th>
        <th>condition</th>
        <th>description</th>
    </tr>
    </thead>
    <tbody>
    {% for callback in state.callbacks | sort(attribute='id')  %}
    <tr>
        <td>
            <a href="{{url_for('web.web_callback', id=callback.id) }}">
                {{callback.label}}
            </a>
        </td>
        <td>
            {{callback.function}}
        </td>
        <td>
            <code>
                {{callback.condition}}
            </code>
        </td>
        <td>{{callback.description}}</td>
    </tr>
    {% endfor %}
    </tbody>
</table>
{{ collapse_card_end("Callbacks") }}

{% endblock %}

studygovernor/templates/state_workflow.html
{% extends "base.html" %}
{% from "_macros.html" import collapse_card_start, collapse_card_end, paginate %}
{% block content %}

<h1>State Overview for: <span class="badge badge-primary">{{ current_workflow.label }}</span></h1>
<div align="right">
<a class="dropdown-toggle" data-toggle="dropdown" href="#" role="button" aria-haspopup="true" aria-expanded="false">Workflows</a>
  <div class="dropdown-menu" >
      <a class="dropdown-item" href="{{url_for('web.web_states')}}">-</a>
      
      {% for workflow in workflows %}
      <div class="dropdown-divider"></div>
      <a class="dropdown-item" href="{{url_for('web.web_state_workflow', id=workflow.id) }}">{{workflow.label}}</a>
      {% endfor %}
  </div>
</div>
{{ collapse_card_start("States", show=True, data_count=states.total)}}
  <table class="table table-striped">

    <thead>
    <tr>
      <th>label</th>
      <th># experiments</th>
      <th>freetext</th>
    </tr>
    </thead>
    <tbody>
    {% for state in states.items %}
    <tr>
      <td>
        <a href="{{url_for('web.web_state', id=state.id) }}">
          {{state.label}}
        </a>
      </td>
      <td>
        {% if state.experiments|length > 0 %}
          <span class="badge badge-secondary">{{state.experiments|length}}</span>
        {% endif %}
      </td>
      <td>{{state.freetext}}</td>
    </tr>
      {% endfor %}
    </tbody>
  </table>

  {{ paginate(states, "web.web_state_workflow", current_workflow.id) }}

{{ collapse_card_end("States") }}



{% endblock %}

studygovernor/templates/subject.html
{% extends "base.html" %}
{% from "_macros.html" import collapse_card_start, collapse_card_end %}
{% block content %}


<h1>Subject {{ subject.label}} </h1>

{{ collapse_card_start("Subject Information", show=True)}}
    <dl class="dl-horizontal">
      <dt>id</dt>
      <dd>{{ subject.id }}</dd>

      <dt>label</dt>
      <dd>{{ subject.label }}</dd>

      <dt>date of birth</dt>
      <dd>{{ subject.date_of_birth }}</dd>

      <dt>cohort</dt>
      <dd>
        {% if subject.cohort %}
        <a href="{{url_for('web.web_cohort', id=subject.cohort.id) }}">
          {{subject.cohort.label}}
        </a>
        {% endif %}
      </dd>

      {% if subject.external_ids %}
      <dt>external ids</dt>
      <dd><p>
        {% for external_system, external_id in subject.external_ids.items() %}
        <span class="badge badge-success">{{ external_system }}: {{ external_id }}</span>
        {% endfor %}
      </p></dd>
      {% endif %}
    </dl>
{{ collapse_card_end("Subject Information")}}

{% if subject.experiments %}
{{ collapse_card_start("Experiments", show=True, data_count=subject.experiments|length) }}
      <table class="table table-striped">
        <thead>
        <tr>
          <th>id</th>
          <th>label</th>
          <th>scan date</th>
        </tr>
        </thead>
        <tbody>
        {% for experiment in subject.experiments | sort(attribute='id') %}
        <tr>
          <td>
            <a href="{{ url_for('web.web_experiment', id=experiment.id) }}">
              {{experiment.id}}
            </a>
          </td>
          <td>
            <a href="{{ url_for('web.web_experiment', id=experiment.id) }}">
              {{experiment.label}}
            </a>
          </td>
          <td>{{experiment.scandate}}</td>
        </tr>
        {% endfor %}
        </tbody>
      </table>
{{ collapse_card_end("Experiments") }}
{% endif %}

{% endblock %}

studygovernor/templates/transition.html
{% extends "base.html" %}
{% from "_macros.html" import collapse_card_start, collapse_card_end %}
{% block content %}

<h1>Transition {{ transition.id}} </h1>

    {{ collapse_card_start("Info", show=True) }}
      <dl class="row">
        <dt class="col-sm-3">id</dt>
        <dd class="col-sm-9">{{ transition.id }}</dd>

        <dt class="col-sm-3">source state</dt>
        <dd class="col-sm-9">
          <a href="{{url_for('web.web_state', id=transition.source_state_id) }}">
              [{{transition.source_state_id}}] {{transition.source_state.label}}
          </a>
        </dd>

        <dt class="col-sm-3">destination state</dt>
        <dd class="col-sm-9">
          <a href="{{url_for('web.web_state', id=transition.destination_state_id) }}">
             [{{transition.destination_state_id}}] {{transition.destination_state.label}}
          </a>
        </dd>

        <dt class="col-sm-3">condition</dt>
        <dd class="col-sm-9">
            {{ transition.condition | python_code }}
        </dd>

      </dl>
    {{ collapse_card_end("Info") }}

{% if transition.actions %}
    {{ collapse_card_start("Actions", show=True, data_count=transition.actions|length) }}
      <table class="table table-striped">
        <thead>
        <tr>
          <th>id</th>
          <th>time</th>
          <th>experiment</th>
          <th>start state</th>
          <th>end state</th>
          <th>callback success</th>
          <th>callback finished</th>
          <th>description</th>
        </tr>
        </thead>
        <tbody>
        {% for action in transition.actions | sort(attribute='id')  %}
        <tr>
          <td>{{action.id}}</td>
          <td>{{action.start_time}}</td>
          <td>
            <a href="{{url_for('web.web_experiment', id=action.experiment_id) }}">
              [{{action.experiment_id}}] {{action.experiment.label}}
            </a>
          </td>
          <td>
            <a href="{{url_for('web.web_state', id=action.transition.source_state.id) }}">
              [{{action.transition.source_state.id}}] {{action.transition.source_state.label}}
            </a>
          </td>
          <td>
            <a href="{{url_for('web.web_state', id=action.transition.destination_state.id) }}">
              [{{action.transition.destination_state.id}}] {{action.transition.destination_state.label}}
            </a>
          </td>
          <td>
            <span class="badge badge-{{ 'success' if action.success else 'danger' }}">
              {{action.success}}
            </span>
          </td>
          <td>{{action.end_time}}</td>
          <td>{{action.free_text}}</td>
        </tr>
        {% endfor %}
        </tbody>
      </table>
    {{ collapse_card_end("Actions") }}
{% endif %}


{% endblock %}

studygovernor/templates/upload_data.html
{% extends "base.html" %}
{% from "_macros.html" import render_field_with_errors, render_field %}

{% block content %}
    {% if success %}
        <div class="alert alert-success">
            <strong>Upload succeeded!</strong> {{ message }}
        </div>
    {% elif message %}
        <div class="alert alert-danger">
            <strong>Upload failed!</strong> {{ message }}
        </div>
    {% endif %}
    <div class="card">
        <h5 class="card-header">Upload data to StudyGovernor</h5>
        <div class="card-body">
            <form action="{{ url_for('web.upload_data') }}" method="POST" name="upload_form"  enctype="multipart/form-data">
                {{ upload_form.hidden_tag() }}
                {{ render_field_with_errors(upload_form.file_field) }}
                {{ render_field(upload_form.submit) }}
            </form>
        </div>
    </div>
{% endblock %}